// Copyright 2000-2024 JetBrains s.r.o. and contributors. Use of this source code is governed by the Apache 2.0 license.
package com.jetbrains.performancePlugin.remotedriver.xpath

import com.intellij.openapi.extensions.ExtensionPointName
import org.w3c.dom.Document
import org.w3c.dom.Element
import java.awt.Component

interface XpathDataModelSubTreeProvider {
  companion object {
    val EP_NAME = ExtensionPointName<XpathDataModelSubTreeProvider>("com.jetbrains.performancePlugin.remoteDriver.xpathDataModelExtension")
  }

  fun shouldOverrideSubtree(component: Component): Boolean
  fun overrideSubtree(doc: Document, parentElement: Element, component: Component)
}